version: '3.5'

services:
    db:
        image: postgres:12.7
        environment:
            POSTGRES_USER: ${POSTGRES_USER:-app}
            POSTGRES_PASSWORD: ${POSTGRES_PASSWORD:-app}
            POSTGRES_DB: app
            # PGDATA: /data/postgres
        restart: "no"

    app-migrations:
        build:
            context: .
            dockerfile: src/Dockerfile
        depends_on:
            - db
        environment: 
            DATABASE_URL: postgres://app:app@db:5432/app
        command: 
            - python
            - manage.py
            - migrate
            - --noinput
        restart: "no"

    app-create-superuser:
        user: ${UID}
        build:
            context: .
            dockerfile: src/Dockerfile
        depends_on:
            - app-migrations
        environment: 
            DATABASE_URL: postgres://app:app@db:5432/app
            DJANGO_SUPERUSER_PASSWORD: teste
        command: 
            - python
            - manage.py
            - createsuperuser
            - --noinput
            - --username
            - teste
            - --email
            - teste@localhost
        restart: "no"

    app-collectstatic:
        user: ${UID}
        build:
            context: .
            dockerfile: src/Dockerfile
        depends_on:
            - db
        environment: 
            DATABASE_URL: postgres://app:app@db:5432/app
            STATIC_ROOT: /app/static/
        volumes:
            - type: bind
              source: ./appdata/app/static/
              target: /app/static/
        command: 
            - python
            - manage.py
            - collectstatic
            - --noinput
        restart: "no"

    app:
        user: ${UID}
        build:
            context: .
            dockerfile: src/Dockerfile
        depends_on:
            - db
        environment: 
            DATABASE_URL: postgres://app:app@db:5432/app
            STATIC_ROOT: /app/static/
        volumes:
            - type: bind
              source: ./appdata/app/static
              target: /app/static
        ports: 
            - 8000
        restart: "no"